
{
  open Parse   (* ./parse.mly *)
  open Lexing  (* librairie standard *)
}

let varname = ['a'-'z']*

rule token = parse

  | ":="               { ASSIGN }
  | "skip"             { SKIP }
  | ";"                { SEQ }
  | "if"               { IF }
  | "then"             { THEN }
  | "else"             { ELSE }
  | "while"            { WHILE }
  | "do"               { DO }
  | "begin"            { BEGIN }
  | "end"              { END }

  | varname as v       { VAR v }
  | "\"toto\""         { STRING "toto" }
  | "42"               { INT 42 }

  | "("                { LPAR }
  | ")"                { RPAR }

  | "+"                { BIN_PLUS "+" }
  | "*"                { BIN_MULT "*" }
  | "<"                { BIN_CMP "<" }

  | "and"              { AND }
  | "or"               { OR }
  | "not"              { NOT }

  | [' ' '\t' '\r' '\n']+   { token lexbuf }

  | eof                { EOF }
